# SoVRMLGeometry Class Reference

`#include <Inventor/VRMLnodes/SoVRMLGeometry.h>`

Inheritance diagram for SoVRMLGeometry:

List of all members.

## Detailed Description

The SoVRMLGeometry class is a superclass for VRML shapes.

## Public Member Functions

virtual void | search (SoSearchAction *action)
virtual void | copyContents (const SoFieldContainer *from, SbBool copyConn)

## Static Public Member Functions

void | initClass (void)

## Protected Member Functions

| SoVRMLGeometry (void)
virtual | ~SoVRMLGeometry ()
void | setupShapeHints (SoState *state, const SbBool ccw, const SbBool solid)
virtual SbBool | shouldGLRender (SoGLRenderAction *action)
virtual SoChildList * | getChildren (void) const
virtual void | notify (SoNotList *list)

## Constructor & Destructor Documentation

SoVRMLGeometry::SoVRMLGeometry | ( | void |  | ) | `[protected]`

| Constructor.

SoVRMLGeometry::~SoVRMLGeometry | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoVRMLGeometry::initClass | ( | void |  | ) | `[static]`

Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.

Reimplemented from SoShape.

Reimplemented in SoVRMLBox, SoVRMLCone, SoVRMLCylinder, SoVRMLElevationGrid, SoVRMLExtrusion, SoVRMLIndexedFaceSet, SoVRMLIndexedLine, SoVRMLIndexedLineSet, SoVRMLIndexedShape, SoVRMLPointSet, SoVRMLSphere, SoVRMLText, SoVRMLVertexLine, SoVRMLVertexPoint, and SoVRMLVertexShape.

void SoVRMLGeometry::search | ( | SoSearchAction * | action | ) | `[virtual]`

Action method for SoSearchAction.

Compares the search criteria from the action to see if this node is a match. Searching is done by matching up all criteria set up in the SoSearchAction -- if any of the requested criteria is a miss, the search is not deemed successful for the node.

See also:
  SoSearchAction

Reimplemented from SoNode.

void SoVRMLGeometry::copyContents | ( | const SoFieldContainer * | from,
|  | SbBool | copyConn
| ) | `[virtual]`

Makes a deep copy of all data of from into this instance, except external scenegraph references if copyconnections is `FALSE`.

This is the protected method that should be overridden by extension node / engine / dragger / whatever subclasses which needs to account for internal data that are not handled automatically.

Note that for simply copying e.g. a node from application code, it should be sufficient to do:

      SoNode * mynewnode = templatenode->copy();

Make sure that when you override the copyContents() method in your extension class that you also make it call upwards to it's parent superclass in the inheritance hierarchy, as copyContents() in for instance SoNode and SoFieldContainer does important work. It should go something like this:

      void
      MyCoinExtensionNode::copyContents(const SoFieldContainer * from,
                                        SbBool copyconnections)
      {
        // let parent superclasses do their thing (copy fields, copy
        // instance name, etc etc)
        SoNode::copyContents(from, copyconnections);

        // [..then copy internal data..]
      }

Reimplemented from SoNode.

void SoVRMLGeometry::setupShapeHints | ( | SoState * | state,
|  | const SbBool | ccw,
|  | const SbBool | solid
| ) | `[protected]`

| Convenience method that updates the shape hints element.

SbBool SoVRMLGeometry::shouldGLRender | ( | SoGLRenderAction * | action | ) | `[protected, virtual]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Reimplemented from SoShape. Reimplemented in SoVRMLVertexLine, SoVRMLVertexPoint, and SoVRMLVertexShape.

SoChildList * SoVRMLGeometry::getChildren | ( | void |  | ) | const`[protected, virtual]`

| Returns list of children for this node. Reimplemented from SoNode. Reimplemented in SoVRMLText.

void SoVRMLGeometry::notify | ( | SoNotList * | list | ) | `[protected, virtual]`

| Notifies all auditors for this instance when changes are made. Reimplemented from SoShape. Reimplemented in SoVRMLElevationGrid, SoVRMLExtrusion, SoVRMLIndexedLine, SoVRMLIndexedShape, SoVRMLText, SoVRMLVertexLine, SoVRMLVertexPoint, and SoVRMLVertexShape.

The documentation for this class was generated from the following files:

- SoVRMLGeometry.h
- Geometry.cpp